/**
 * This file is a part of DesQ Session.
 * DesQSession is the Session Manager for DesQ DE.
 * Copyright 2019-2022 Britanicus <marcusbritanicus@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option, any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 **/

#include "SessionAdaptor.hpp"

#include <QtCore/QMetaObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>

DesQ::Session::Adaptor::Adaptor( QObject *parent ) : QDBusAbstractAdaptor( parent ) {
    setAutoRelaySignals( true );
}


void DesQ::Session::Adaptor::Logout() {
    QMetaObject::invokeMethod( parent(), "handleMessages", Q_ARG( QString, "logout" ) );
}


void DesQ::Session::Adaptor::Suspend() {
    QMetaObject::invokeMethod( parent(), "handleMessages", Q_ARG( QString, "suspend" ) );
}


void DesQ::Session::Adaptor::Hibernate() {
    QMetaObject::invokeMethod( parent(), "handleMessages", Q_ARG( QString, "hibernate" ) );
}


void DesQ::Session::Adaptor::Shutdown() {
    QMetaObject::invokeMethod( parent(), "handleMessages", Q_ARG( QString, "shutdown" ) );
}


void DesQ::Session::Adaptor::Reboot() {
    QMetaObject::invokeMethod( parent(), "handleMessages", Q_ARG( QString, "reboot" ) );
}


bool DesQ::Session::Adaptor::CanSuspend() {
    bool retVal;

    QMetaObject::invokeMethod( parent(), "handleMessages", Q_RETURN_ARG( bool, retVal ), Q_ARG( QString, "CanSuspend" ) );

    return retVal;
}


bool DesQ::Session::Adaptor::CanHibernate() {
    bool retVal;

    QMetaObject::invokeMethod( parent(), "handleMessages", Q_RETURN_ARG( bool, retVal ), Q_ARG( QString, "CanHibernate" ) );

    return retVal;
}


bool DesQ::Session::Adaptor::CanShutdown() {
    bool retVal;

    QMetaObject::invokeMethod( parent(), "handleMessages", Q_RETURN_ARG( bool, retVal ), Q_ARG( QString, "CanShutdown" ) );

    return retVal;
}


bool DesQ::Session::Adaptor::CanReboot() {
    bool retVal;

    QMetaObject::invokeMethod( parent(), "handleMessages", Q_RETURN_ARG( bool, retVal ), Q_ARG( QString, "CanReboot" ) );

    return retVal;
}
